unit coscomdll;

interface

uses
    Windows
    ;

const
     DefCoscomDLLName = 'coscomekg.dll';
type
    TCOSCOMFUNC              = function (portnumber : Integer) : Integer; stdcall;
    TCOSCOMGETPCHARFUNC      = function (portnumber : Integer;versionchars : PCHAR) : Integer; stdcall;
    TCOSCOMGETDOUBLEFUNC     = function (portnumber : Integer;value : PDouble) : Integer; stdcall;
    TCOSCOMGETINTEGERFUNC    = function (portnumber : Integer;value : PInteger) : Integer; stdcall;

    TCOSCOMSETDOUBLEFUNC     = function (portnumber : Integer;value : Double) : Integer; stdcall;
    TCOSCOMSETINTEGERFUNC    = function (portnumber : Integer;value : Integer) : Integer; stdcall;
    TCOSCOMSETSPEEDACCELFUNC = function (portnumber : Integer;value : Double;accelerationindex : Integer) : Integer; stdcall;

    TCOSCOMBUTTONFUNC        = function (portnumber : Integer;how : Integer) : Integer; stdcall;
var
    CoscomDLLHandle : THandle;
    CoscomDLLName   : string;
    coscomopenPort : TCOSCOMFUNC;
    coscomclosePort : TCOSCOMFUNC;
    coscomgetVersion : TCOSCOMGETPCHARFUNC;
    coscomgetStatus : TCOSCOMGETINTEGERFUNC;
    coscomgetDuration : TCOSCOMGETINTEGERFUNC;
    coscomgetSpeed : TCOSCOMGETDOUBLEFUNC;
    coscomgetAcceleration : TCOSCOMGETINTEGERFUNC;
    coscomgetElevation : TCOSCOMGETDOUBLEFUNC;
    coscomgetHeartrate : TCOSCOMGETINTEGERFUNC;
    coscomgetDistance : TCOSCOMGETINTEGERFUNC;
    coscomgetError : TCOSCOMGETINTEGERFUNC;
    coscomsetSpeed : TCOSCOMSETDOUBLEFUNC;
    coscomsetAcceleration : TCOSCOMSETINTEGERFUNC;
    coscomsetElevation : TCOSCOMSETDOUBLEFUNC;
    coscomsetSpeedAccel : TCOSCOMSETSPEEDACCELFUNC;
    coscomKeyPressStart : TCOSCOMBUTTONFUNC;
    coscomKeyPressStop : TCOSCOMBUTTONFUNC;
    coscomKeyPressPlus : TCOSCOMBUTTONFUNC;
    coscomKeyPressMinus : TCOSCOMBUTTONFUNC;
    coscomKeyPressUp : TCOSCOMBUTTONFUNC;
    coscomKeyPressDown : TCOSCOMBUTTONFUNC;
    coscomsetFailSafe : TCOSCOMSETINTEGERFUNC;
    coscomgetFailSafe : TCOSCOMGETINTEGERFUNC;
    coscomgetProtocol : TCOSCOMGETINTEGERFUNC;
    coscomsetProtocol : TCOSCOMSETINTEGERFUNC;

implementation

uses
    Sysutils
    ;
procedure resetCoscomPointer;
begin
    CoscomDLLHandle := 0;
    CoscomDLLName :=  ExtractFilePath(ParamStr(0)) + DefCoscomDLLName;
    coscomopenPort := nil;
    coscomclosePort := nil;
    coscomgetVersion := nil;
    coscomgetStatus := nil;
    coscomgetDuration := nil;
    coscomgetSpeed := nil;
    coscomgetAcceleration := nil;
    coscomgetElevation := nil;
    coscomgetHeartrate := nil;
    coscomgetDistance := nil;
    coscomgetError := nil;
    coscomsetSpeed := nil;
    coscomsetAcceleration := nil;
    coscomsetElevation := nil;
    coscomsetSpeedAccel := nil;
    coscomKeyPressStart := nil;
    coscomKeyPressStop := nil;
    coscomKeyPressPlus := nil;
    coscomKeyPressMinus := nil;
    coscomKeyPressUp := nil;
    coscomKeyPressDown := nil;
    coscomsetFailSafe := nil;
    coscomgetFailSafe := nil;
    coscomgetProtocol := nil;
    coscomsetProtocol := nil;
end;

function areValidCoscomPointer : Boolean;
begin
    Result :=
    (@coscomopenPort <> nil)
    and (@coscomclosePort <> nil)
    and (@coscomgetVersion <> nil)
    and (@coscomgetStatus <> nil)
    and (@coscomgetDuration <> nil)
    and (@coscomgetSpeed <> nil)
    and (@coscomgetAcceleration <> nil)
    and (@coscomgetElevation <> nil)
    and (@coscomgetHeartrate <> nil)
    and (@coscomgetDistance <> nil)
    and (@coscomgetError <> nil)
    and (@coscomsetSpeed <> nil)
    and (@coscomsetAcceleration <> nil)
    and (@coscomsetElevation <> nil)
    and (@coscomsetSpeedAccel <> nil)
    and (@coscomKeyPressStart <> nil)
    and (@coscomKeyPressStop <> nil)
    and (@coscomKeyPressPlus <> nil)
    and (@coscomKeyPressMinus <> nil)
    and (@coscomKeyPressUp <> nil)
    and (@coscomKeyPressDown <> nil)
    and (@coscomsetFailSafe <> nil)
    and (@coscomgetFailSafe <> nil)
    and (@coscomgetProtocol <> nil)
    and (@coscomsetProtocol <> nil)
    ;
end;

procedure getCoscomPointer;
begin
     if CoscomDLLHandle = 0 then
        exit;
    @coscomopenPort := GetProcAddress(CoscomDLLHandle,PChar('coscomopenPort'));
    @coscomclosePort := GetProcAddress(CoscomDLLHandle,PChar('coscomclosePort'));
    @coscomgetVersion := GetProcAddress(CoscomDLLHandle,PChar('coscomgetVersion'));
    @coscomgetStatus := GetProcAddress(CoscomDLLHandle,PChar('coscomgetStatus'));
    @coscomgetDuration := GetProcAddress(CoscomDLLHandle,PChar('coscomgetDuration'));
    @coscomgetSpeed := GetProcAddress(CoscomDLLHandle,PChar('coscomgetSpeed'));
    @coscomgetAcceleration := GetProcAddress(CoscomDLLHandle,PChar('coscomgetAcceleration'));
    @coscomgetElevation := GetProcAddress(CoscomDLLHandle,PChar('coscomgetElevation'));
    @coscomgetHeartrate := GetProcAddress(CoscomDLLHandle,PChar('coscomgetHeartrate'));
    @coscomgetDistance := GetProcAddress(CoscomDLLHandle,PChar('coscomgetDistance'));
    @coscomgetError := GetProcAddress(CoscomDLLHandle,PChar('coscomgetError'));
    @coscomsetSpeed := GetProcAddress(CoscomDLLHandle,PChar('coscomsetSpeed'));
    @coscomsetAcceleration := GetProcAddress(CoscomDLLHandle,PChar('coscomsetAcceleration'));
    @coscomsetElevation := GetProcAddress(CoscomDLLHandle,PChar('coscomsetElevation'));
    @coscomsetSpeedAccel := GetProcAddress(CoscomDLLHandle,PChar('coscomsetSpeedAccel'));
    @coscomKeyPressStart := GetProcAddress(CoscomDLLHandle,PChar('coscomKeyPressStart'));
    @coscomKeyPressStop := GetProcAddress(CoscomDLLHandle,PChar('coscomKeyPressStop'));
    @coscomKeyPressPlus := GetProcAddress(CoscomDLLHandle,PChar('coscomKeyPressPlus'));
    @coscomKeyPressMinus := GetProcAddress(CoscomDLLHandle,PChar('coscomKeyPressMinus'));
    @coscomKeyPressUp := GetProcAddress(CoscomDLLHandle,PChar('coscomKeyPressUp'));
    @coscomKeyPressDown := GetProcAddress(CoscomDLLHandle,PChar('coscomKeyPressDown'));
    @coscomsetFailSafe := GetProcAddress(CoscomDLLHandle,PChar('coscomsetFailSafe'));
    @coscomgetFailSafe := GetProcAddress(CoscomDLLHandle,PChar('coscomgetFailSafe'));
    @coscomgetProtocol := GetProcAddress(CoscomDLLHandle,PChar('coscomgetProtocol'));
    @coscomsetProtocol := GetProcAddress(CoscomDLLHandle,PChar('coscomsetProtocol'));
end;


initialization
              resetCoscomPointer;
              CoscomDLLHandle := LoadLibrary(PChar(CoscomDLLName));
              getCoscomPointer;
              if (CoscomDLLHandle = 0) or not areValidCoscomPointer then
              begin
                   //Fehler
              end;
finalization
            if CoscomDLLHandle <> 0 then
              FreeLibrary(CoscomDLLHandle);
end.
